/**
 * \mainpage
 * \section Intro Introduction
 *
 * \section HW Hardware Setup
 *
 * Port Connections:
 *
 *
 * \section TDL ToDo List
 */

#include "AVR_USART.h"
#include "cmd_interface.h"
#include "string_addon.h"
#include <ctype.h>



/* Function Prototypes
   ************************************************/
	void init_ports();
    uint8_t command_0(char *opt1,char *opt2,char *opt3,char *opt4);
    uint8_t command_1(char *opt1,char *opt2,char *opt3,char *opt4);

/* Defines
   ************************************************/
	#define _CR	13
	#define _LF	10
	#define _terminal_startup_message "\n The AVR is ready to receive your commands"


/* redirect stdout >> USART
   ************************************************/

	/* define function for stdout */
	int stdout_usart( char c, FILE *stream ) { 	Usart_putc(c); 	return 0; 	}
	/* eigenen Stream erzeugen
		define FDEV_SETUP_STREAM  (	put,  	- Funktionpointer auf Schreibfunktion
									get,    - Funktionspointer auf Lesefunktion
									rwflag  - Schreib/Lesezugriff
									)

	*/
	static FILE mystdout = FDEV_SETUP_STREAM( stdout_usart, NULL, _FDEV_SETUP_WRITE );


/**	*
  	*	MAIN
  	*
	******************************************************************/

	extern char   	cmd_line[];

int main(void){
	int8_t iCnt=0;
//	uint8_t uiRetVal =0;
	char str_rcv_usart[180]="";


	/* redirect stdout into our own stream */
	stdout = &mystdout;

	/* Initialisation */
	init_ports();
	init_usart_9600_8_1_N_Asyn();
	cmd_interface_init();

	/* add command-functions to command-interface */
	cmd_interface_table[0].cmd="a";
	cmd_interface_table[0].cmd_func_ptr = *command_0;
	cmd_interface_table[1].cmd="cmd";
	cmd_interface_table[1].cmd_func_ptr = *command_1;

	
	/* enable interrupts */
	sei();

	printf(_terminal_startup_message);

	while(1){
		printf("\n\rcmd>");
		do {
			usart_read_buffer_string((uint8_t *)&str_rcv_usart[0]);
			iCnt=execute_cmd_interface(&str_rcv_usart[0]);
		}while(0==iCnt);
		if (iCnt<0) {
			printf ("\n\r Error: %x",iCnt);
			printf ("\n\r >>");
			printf ("%s",cmd_line);
		} else {
			printf ("\n\r ci: %d commands ",iCnt);
		}
	}/* while(1) */


} /* int main (void) */

/**	*
  	*	Funktionen
  	*
	******************************************************************/

void init_ports(){
	/* Define directions for port pins ... 0 = Input; 1 = Output*/
		DDRA = (0<<DDA7)|(0<<DDA6)|(0<<DDA5)|(0<<DDA4)|(0<<DDA3)|(0<<DDA2)|(0<<DDA1)|(0<<DDA0);
		PORTA = (0<<PA7)|(0<<PA6)|(0<<PA5)|(0<<PA4)|(0<<PA3)|(0<<PA2)|(0<<PA1)|(0<<PA0); /* 0 = no PullUps */
	/* Define directions for port pins ... 0 = Input; 1 = Output*/
		DDRB = (0<<DDB7)|(1<<DDB6)|(0<<DDB5)|(0<<DDB4)|(1<<DDB3)|(1<<DDB2)|(1<<DDB1)|(1<<DDB0);
		PORTB = (1<<PB7)|(0<<PB6)|(1<<PB5)|(1<<PB4)|(0<<PB3)|(0<<PB2)|(0<<PB1)|(0<<PB0); /* 0 = no PullUps */
	/* Define directions for port pins ... 0 = Input; 1 = Output*/
		DDRC = (0<<DDC7)|(0<<DDC6)|(0<<DDC5)|(0<<DDC4)|(0<<DDC3)|(0<<DDC2)|(0<<DDC1)|(0<<DDC0);
		PORTC = (0<<PC7)|(0<<PC6)|(0<<PC5)|(0<<PC4)|(0<<PC3)|(0<<PC2)|(0<<PC1)|(0<<PC0); /* 0 = no PullUps */
	/* Define directions for port pins ... 0 = Input; 1 = Output*/
		DDRD = (0<<DDD7)|(0<<DDD6)|(0<<DDD5)|(0<<DDD4)|(0<<DDD3)|(1<<DDD2)|(0<<DDD1)|(0<<DDD0);
		PORTD = (0<<PD7)|(0<<PD6)|(0<<PD5)|(0<<PD4)|(0<<PD3)|(0<<PD2)|(0<<PD1)|(0<<PD0); /* 0 = no PullUps */
} /* void init_ports() */


uint8_t command_0(char *opt1,char *opt2,char *opt3,char *opt4){
	printf("\n\r...received command 0, with option 1:%s;2:%s;3:%s;4:%s; \n\r end",opt1,opt2,opt3,opt4);
	return 0;
}

uint8_t command_1(char *opt1,char *opt2,char *opt3,char *opt4){
	printf("\n\r...received command 1, with option 1:%s;2:%s;3:%s;4:%s; \n\r end",opt1,opt2,opt3,opt4);
	return 0;
}
